//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_indexer_lucene_plugin_ns0_artifact_info_resource_H
#define DEF_nexus_indexer_lucene_plugin_ns0_artifact_info_resource_H

/**
 *  Details about the requested item, that should be useful in
 finding how the item was retrieved.
       
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource {


  /**
   * The flag that marks item as locally present (hosted/cached).
   */
  int presentLocally;

  /**
   * The repository where the artifact is stored.
   */
  xmlChar *repositoryId;

  /**
   * The repository name where the artifact is stored.
   */
  xmlChar *repositoryName;

  /**
   * The path in repository where the artifact is stored.
   */
  xmlChar *repositoryPath;

  /**
   * The MIME type of the artifact.
   */
  xmlChar *mimeType;

  /**
   * User id that uploaded the artifact.
   */
  xmlChar *uploader;

  /**
   * When the artifact was uploaded.
   */
  long uploaded;

  /**
   * When the artifact was changed for the last time.
   */
  long lastChanged;

  /**
   * Artifact size on disk.
   */
  long size;

  /**
   * Sha1 Hash.
   */
  xmlChar *sha1Hash;

  /**
   * Md5 Hash.
   */
  xmlChar *md5Hash;

  /**
   * Field repositories.
   */
  struct nexus_indexer_lucene_plugin_ns0_repository_url_resource *repositories;

  /**
   * Size of the repositories array.
   */
  int _sizeof_repositories;

  /**
   * Informs if current user has what is needed to delete this
artifact.
   */
  int canDelete;
};

/**
 * Reads a ArtifactInfoResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ArtifactInfoResource, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource *xmlTextReaderReadNs0Artifact_info_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a ArtifactInfoResource to XML.
 *
 * @param writer The XML writer.
 * @param _artifactInfoResource The ArtifactInfoResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Artifact_info_resourceType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource *_artifactInfoResource);

/**
 * Frees the elements of a ArtifactInfoResource.
 *
 * @param _artifactInfoResource The ArtifactInfoResource to free.
 */
static void freeNs0Artifact_info_resourceType(struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource *_artifactInfoResource);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_artifact_info_resource_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse_H
#define DEF_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse_H

/**
 *  REST Response object for a artifact-info resource request,
 contains the typical 'data' parameter,
         which is the content items requested.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse {


  /**
   * List of describe items, that will contain useful information
about the retrieved data.
   */
  struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource *data;
};

/**
 * Reads a ArtifactInfoResourceResponse element from XML. The element to be read is "artifact-info", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ArtifactInfoResourceResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *xml_read_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a ArtifactInfoResourceResponse to XML under element name "artifact-info".
 *
 * @param writer The XML writer.
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse);

/**
 * Frees a ArtifactInfoResourceResponse.
 *
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to free.
 */
void free_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse(struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse);

/**
 * Reads a ArtifactInfoResourceResponse element from XML. The element to be read is "artifact-info", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ArtifactInfoResourceResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *xmlTextReaderReadNs0Artifact_infoElement(xmlTextReaderPtr reader);

/**
 * Writes a ArtifactInfoResourceResponse to XML under element name "artifact-info".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Artifact_infoElement(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse);

/**
 * Writes a ArtifactInfoResourceResponse to XML under element name "artifact-info".
 *
 * @param writer The XML writer.
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Artifact_infoElementNS(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse, int writeNamespaces);

/**
 * Frees the children of a ArtifactInfoResourceResponse.
 *
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse whose children are to be free.
 */
static void freeNs0Artifact_infoElement(struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse);

/**
 * Reads a ArtifactInfoResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ArtifactInfoResourceResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *xmlTextReaderReadNs0ArtifactInfoResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a ArtifactInfoResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ArtifactInfoResourceResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse);

/**
 * Frees the elements of a ArtifactInfoResourceResponse.
 *
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to free.
 */
static void freeNs0ArtifactInfoResourceResponseType(struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_nexus_artifact_H
#define DEF_nexus_indexer_lucene_plugin_ns0_nexus_artifact_H

/**
 *  Artifact details sent back on search requests.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_nexus_artifact {


  /**
   * The URL that can be used to retrieve the artifact.
   */
  xmlChar *resourceURI;

  /**
   * The group id of the artifact.
   */
  xmlChar *groupId;

  /**
   * The artifact id of the artifact.
   */
  xmlChar *artifactId;

  /**
   * The version of the artifact.
   */
  xmlChar *version;

  /**
   * The classifier of the artifact.
   */
  xmlChar *classifier;

  /**
   * The packaging of the artifact.
   */
  xmlChar *packaging;

  /**
   * The extension of the artifact.
   */
  xmlChar *extension;

  /**
   * The repository id where the artifact is stored.
   */
  xmlChar *repoId;

  /**
   * The indexing context where the artifact is indexed.
   */
  xmlChar *contextId;

  /**
   * URL that would give you the pom file.
   */
  xmlChar *pomLink;

  /**
   * URL that would give you the artifact file.
   */
  xmlChar *artifactLink;

  /**
   * A HTML highlighted fragment of the matched hit.
   */
  xmlChar *highlightedFragment;
};

/**
 * Reads a NexusArtifact from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusArtifact, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_nexus_artifact *xmlTextReaderReadNs0Nexus_artifactType(xmlTextReaderPtr reader);

/**
 * Writes a NexusArtifact to XML.
 *
 * @param writer The XML writer.
 * @param _nexusArtifact The NexusArtifact to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Nexus_artifactType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_nexus_artifact *_nexusArtifact);

/**
 * Frees the elements of a NexusArtifact.
 *
 * @param _nexusArtifact The NexusArtifact to free.
 */
static void freeNs0Nexus_artifactType(struct nexus_indexer_lucene_plugin_ns0_nexus_artifact *_nexusArtifact);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_nexus_artifact_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse_H
#define DEF_nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse_H

/**
 *  Class NexusIndexerResponse.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse {

};

/**
 * Reads a NexusIndexerResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusIndexerResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse *xmlTextReaderReadNs0NexusIndexerResponseType(xmlTextReaderPtr reader);

/**
 * Writes a NexusIndexerResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusIndexerResponse The NexusIndexerResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0NexusIndexerResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse *_nexusIndexerResponse);

/**
 * Frees the elements of a NexusIndexerResponse.
 *
 * @param _nexusIndexerResponse The NexusIndexerResponse to free.
 */
static void freeNs0NexusIndexerResponseType(struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse *_nexusIndexerResponse);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_nexusNGArtifact_H
#define DEF_nexus_indexer_lucene_plugin_ns0_nexusNGArtifact_H

/**
 *  Artifact details sent back on search requests.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact {


  /**
   * The group id of the artifact.
   */
  xmlChar *groupId;

  /**
   * The artifact id of the artifact.
   */
  xmlChar *artifactId;

  /**
   * The version of the artifact.
   */
  xmlChar *version;

  /**
   * The latest snapshot version of the artifact.
   */
  xmlChar *latestSnapshot;

  /**
   * The repository of latest snapshot version of the artifact.
   */
  xmlChar *latestSnapshotRepositoryId;

  /**
   * The latest release version of the artifact.
   */
  xmlChar *latestRelease;

  /**
   * The repository of latest release version of the artifact.
   */
  xmlChar *latestReleaseRepositoryId;

  /**
   * A HTML highlighted fragment of the matched hit.
   */
  xmlChar *highlightedFragment;

  /**
   * Field artifactHits.
   */
  struct nexus_indexer_lucene_plugin_ns0_artifactHit *artifactHits;

  /**
   * Size of the artifactHits array.
   */
  int _sizeof_artifactHits;
};

/**
 * Reads a NexusNGArtifact from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusNGArtifact, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact *xmlTextReaderReadNs0NexusNGArtifactType(xmlTextReaderPtr reader);

/**
 * Writes a NexusNGArtifact to XML.
 *
 * @param writer The XML writer.
 * @param _nexusNGArtifact The NexusNGArtifact to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0NexusNGArtifactType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact *_nexusNGArtifact);

/**
 * Frees the elements of a NexusNGArtifact.
 *
 * @param _nexusNGArtifact The NexusNGArtifact to free.
 */
static void freeNs0NexusNGArtifactType(struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact *_nexusNGArtifact);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_nexusNGArtifact_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_artifactHit_H
#define DEF_nexus_indexer_lucene_plugin_ns0_artifactHit_H

/**
 *  Artifact hit details sent back on search requests.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_artifactHit {


  /**
   * The repository ID.
   */
  xmlChar *repositoryId;

  /**
   * Field artifactLinks.
   */
  struct nexus_indexer_lucene_plugin_ns0_artifactLink *artifactLinks;

  /**
   * Size of the artifactLinks array.
   */
  int _sizeof_artifactLinks;
};

/**
 * Reads a NexusNGArtifactHit from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusNGArtifactHit, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_artifactHit *xmlTextReaderReadNs0ArtifactHitType(xmlTextReaderPtr reader);

/**
 * Writes a NexusNGArtifactHit to XML.
 *
 * @param writer The XML writer.
 * @param _nexusNGArtifactHit The NexusNGArtifactHit to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ArtifactHitType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactHit *_nexusNGArtifactHit);

/**
 * Frees the elements of a NexusNGArtifactHit.
 *
 * @param _nexusNGArtifactHit The NexusNGArtifactHit to free.
 */
static void freeNs0ArtifactHitType(struct nexus_indexer_lucene_plugin_ns0_artifactHit *_nexusNGArtifactHit);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_artifactHit_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_artifactLink_H
#define DEF_nexus_indexer_lucene_plugin_ns0_artifactLink_H

/**
 *  Artifact hit link details sent back on search requests.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_artifactLink {


  /**
   * The classifier of the artifact.
   */
  xmlChar *classifier;

  /**
   * The extension of the artifact.
   */
  xmlChar *extension;
};

/**
 * Reads a NexusNGArtifactLink from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusNGArtifactLink, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_artifactLink *xmlTextReaderReadNs0ArtifactLinkType(xmlTextReaderPtr reader);

/**
 * Writes a NexusNGArtifactLink to XML.
 *
 * @param writer The XML writer.
 * @param _nexusNGArtifactLink The NexusNGArtifactLink to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ArtifactLinkType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactLink *_nexusNGArtifactLink);

/**
 * Frees the elements of a NexusNGArtifactLink.
 *
 * @param _nexusNGArtifactLink The NexusNGArtifactLink to free.
 */
static void freeNs0ArtifactLinkType(struct nexus_indexer_lucene_plugin_ns0_artifactLink *_nexusNGArtifactLink);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_artifactLink_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_repositoryDetail_H
#define DEF_nexus_indexer_lucene_plugin_ns0_repositoryDetail_H

/**
 *  Artifact repository details sent back on search requests.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_repositoryDetail {


  /**
   * The repository ID.
   */
  xmlChar *repositoryId;

  /**
   * The repository name.
   */
  xmlChar *repositoryName;

  /**
   * The repository content class.
   */
  xmlChar *repositoryContentClass;

  /**
   * The repository kind (hosted, proxy, group).
   */
  xmlChar *repositoryKind;

  /**
   * The repository policy (RELEASE or SNAPSHOT).
   */
  xmlChar *repositoryPolicy;

  /**
   * The repository base URL.
   */
  xmlChar *repositoryURL;
};

/**
 * Reads a NexusNGRepositoryDetail from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusNGRepositoryDetail, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_repositoryDetail *xmlTextReaderReadNs0RepositoryDetailType(xmlTextReaderPtr reader);

/**
 * Writes a NexusNGRepositoryDetail to XML.
 *
 * @param writer The XML writer.
 * @param _nexusNGRepositoryDetail The NexusNGRepositoryDetail to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RepositoryDetailType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_repositoryDetail *_nexusNGRepositoryDetail);

/**
 * Frees the elements of a NexusNGRepositoryDetail.
 *
 * @param _nexusNGRepositoryDetail The NexusNGRepositoryDetail to free.
 */
static void freeNs0RepositoryDetailType(struct nexus_indexer_lucene_plugin_ns0_repositoryDetail *_nexusNGRepositoryDetail);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_repositoryDetail_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_nexusResponse_H
#define DEF_nexus_indexer_lucene_plugin_ns0_nexusResponse_H

/**
 * (no documentation provided)
 */
struct nexus_indexer_lucene_plugin_ns0_nexusResponse {

};

/**
 * Reads a NexusResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_nexusResponse *xmlTextReaderReadNs0NexusResponseType(xmlTextReaderPtr reader);

/**
 * Writes a NexusResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusResponse The NexusResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0NexusResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_nexusResponse *_nexusResponse);

/**
 * Frees the elements of a NexusResponse.
 *
 * @param _nexusResponse The NexusResponse to free.
 */
static void freeNs0NexusResponseType(struct nexus_indexer_lucene_plugin_ns0_nexusResponse *_nexusResponse);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_nexusResponse_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_repository_url_resource_H
#define DEF_nexus_indexer_lucene_plugin_ns0_repository_url_resource_H

/**
 *  The repository url information for a given artifact.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_repository_url_resource {


  /**
   * The repository where the artifact is stored.
   */
  xmlChar *repositoryId;

  /**
   * The repository where the artifact is stored.
   */
  xmlChar *repositoryName;

  /**
   * The artifact path.
   */
  xmlChar *path;

  /**
   * The artifact url.
   */
  xmlChar *artifactUrl;

  /**
   * Tells if the users has view access to a given artifact.
   */
  int canView;
};

/**
 * Reads a RepositoryUrlResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RepositoryUrlResource, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_repository_url_resource *xmlTextReaderReadNs0Repository_url_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a RepositoryUrlResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryUrlResource The RepositoryUrlResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Repository_url_resourceType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_repository_url_resource *_repositoryUrlResource);

/**
 * Frees the elements of a RepositoryUrlResource.
 *
 * @param _repositoryUrlResource The RepositoryUrlResource to free.
 */
static void freeNs0Repository_url_resourceType(struct nexus_indexer_lucene_plugin_ns0_repository_url_resource *_repositoryUrlResource);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_repository_url_resource_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_searchNGResponse_H
#define DEF_nexus_indexer_lucene_plugin_ns0_searchNGResponse_H

/**
 *  REST Response object for a list of search results, contains the
 typical 'data' parameter, which is a
         list of search results.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_searchNGResponse {


  /**
   * The grand total number of results found on index.
   */
  int totalCount;

  /**
   * The starting index of the results.
   */
  int from;

  /**
   * The number of results in this response.
   */
  int count;

  /**
   * Flag that states if too many results were found.
   */
  int tooManyResults;

  /**
   * Flag that states if result set is collapsed, and shows
latest versions only.
   */
  int collapsed;

  /**
   * Field repoDetails.
   */
  struct nexus_indexer_lucene_plugin_ns0_repositoryDetail *repoDetails;

  /**
   * Size of the repoDetails array.
   */
  int _sizeof_repoDetails;

  /**
   * Field data.
   */
  struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a SearchNGResponse element from XML. The element to be read is "searchNGResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SearchNGResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *xml_read_nexus_indexer_lucene_plugin_ns0_searchNGResponse(xmlTextReaderPtr reader);

/**
 * Writes a SearchNGResponse to XML under element name "searchNGResponse".
 *
 * @param writer The XML writer.
 * @param _searchNGResponse The SearchNGResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_indexer_lucene_plugin_ns0_searchNGResponse(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse);

/**
 * Frees a SearchNGResponse.
 *
 * @param _searchNGResponse The SearchNGResponse to free.
 */
void free_nexus_indexer_lucene_plugin_ns0_searchNGResponse(struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse);

/**
 * Reads a SearchNGResponse element from XML. The element to be read is "searchNGResponse", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The SearchNGResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *xmlTextReaderReadNs0SearchNGResponseElement(xmlTextReaderPtr reader);

/**
 * Writes a SearchNGResponse to XML under element name "searchNGResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _searchNGResponse The SearchNGResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SearchNGResponseElement(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse);

/**
 * Writes a SearchNGResponse to XML under element name "searchNGResponse".
 *
 * @param writer The XML writer.
 * @param _searchNGResponse The SearchNGResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SearchNGResponseElementNS(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse, int writeNamespaces);

/**
 * Frees the children of a SearchNGResponse.
 *
 * @param _searchNGResponse The SearchNGResponse whose children are to be free.
 */
static void freeNs0SearchNGResponseElement(struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse);

/**
 * Reads a SearchNGResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SearchNGResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *xmlTextReaderReadNs0SearchNGResponseType(xmlTextReaderPtr reader);

/**
 * Writes a SearchNGResponse to XML.
 *
 * @param writer The XML writer.
 * @param _searchNGResponse The SearchNGResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SearchNGResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse);

/**
 * Frees the elements of a SearchNGResponse.
 *
 * @param _searchNGResponse The SearchNGResponse to free.
 */
static void freeNs0SearchNGResponseType(struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_searchNGResponse_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_searchResponse_H
#define DEF_nexus_indexer_lucene_plugin_ns0_searchResponse_H

/**
 *  REST Response object for a list of search results, contains the
 typical 'data' parameter, which is a
         list of search results.
 
 @version $Revision$ $Date$

 */
struct nexus_indexer_lucene_plugin_ns0_searchResponse {


  /**
   * The total number of results.
   */
  int totalCount;

  /**
   * The starting index of the results.
   */
  int from;

  /**
   * The number of results in this response.
   */
  int count;

  /**
   * Flag that states if too many results were found.
   */
  int tooManyResults;

  /**
   * Field data.
   */
  struct nexus_indexer_lucene_plugin_ns0_nexus_artifact *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a SearchResponse element from XML. The element to be read is "search-results", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SearchResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_searchResponse *xml_read_nexus_indexer_lucene_plugin_ns0_searchResponse(xmlTextReaderPtr reader);

/**
 * Writes a SearchResponse to XML under element name "search-results".
 *
 * @param writer The XML writer.
 * @param _searchResponse The SearchResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_indexer_lucene_plugin_ns0_searchResponse(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse);

/**
 * Frees a SearchResponse.
 *
 * @param _searchResponse The SearchResponse to free.
 */
void free_nexus_indexer_lucene_plugin_ns0_searchResponse(struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse);

/**
 * Reads a SearchResponse element from XML. The element to be read is "search-results", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The SearchResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_searchResponse *xmlTextReaderReadNs0Search_resultsElement(xmlTextReaderPtr reader);

/**
 * Writes a SearchResponse to XML under element name "search-results".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _searchResponse The SearchResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Search_resultsElement(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse);

/**
 * Writes a SearchResponse to XML under element name "search-results".
 *
 * @param writer The XML writer.
 * @param _searchResponse The SearchResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Search_resultsElementNS(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse, int writeNamespaces);

/**
 * Frees the children of a SearchResponse.
 *
 * @param _searchResponse The SearchResponse whose children are to be free.
 */
static void freeNs0Search_resultsElement(struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse);

/**
 * Reads a SearchResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SearchResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_searchResponse *xmlTextReaderReadNs0SearchResponseType(xmlTextReaderPtr reader);

/**
 * Writes a SearchResponse to XML.
 *
 * @param writer The XML writer.
 * @param _searchResponse The SearchResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SearchResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse);

/**
 * Frees the elements of a SearchResponse.
 *
 * @param _searchResponse The SearchResponse to free.
 */
static void freeNs0SearchResponseType(struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse);

#endif /* DEF_nexus_indexer_lucene_plugin_ns0_searchResponse_H */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_artifact_info_resource_M
#define DEF_nexus_indexer_lucene_plugin_ns0_artifact_info_resource_M

/**
 * Reads a ArtifactInfoResource from XML. The reader is assumed to be at the start element.
 *
 * @return the ArtifactInfoResource, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource *xmlTextReaderReadNs0Artifact_info_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource *_artifactInfoResource = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Artifact_info_resourceType(_artifactInfoResource);
        free(_artifactInfoResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "presentLocally", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}presentLocally of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}presentLocally of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->presentLocally = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->repositoryName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryPath", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryPath of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryPath of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->repositoryPath = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "mimeType", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}mimeType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}mimeType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->mimeType = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "uploader", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}uploader of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}uploader of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->uploader = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "uploaded", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}uploaded of type {http://www.w3.org/2001/XMLSchema}long.\n");
#endif
        _child_accessor = xmlTextReaderReadXsLongType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}uploaded of type {http://www.w3.org/2001/XMLSchema}long.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->uploaded = *((long*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "lastChanged", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}lastChanged of type {http://www.w3.org/2001/XMLSchema}long.\n");
#endif
        _child_accessor = xmlTextReaderReadXsLongType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}lastChanged of type {http://www.w3.org/2001/XMLSchema}long.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->lastChanged = *((long*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "size", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}size of type {http://www.w3.org/2001/XMLSchema}long.\n");
#endif
        _child_accessor = xmlTextReaderReadXsLongType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}size of type {http://www.w3.org/2001/XMLSchema}long.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->size = *((long*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "sha1Hash", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}sha1Hash of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}sha1Hash of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->sha1Hash = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "md5Hash", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}md5Hash of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}md5Hash of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->md5Hash = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Artifact_info_resourceType(_artifactInfoResource);
              free(_artifactInfoResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositories", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositories of type {}repository-url-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Repository_url_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositories of type {}repository-url-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->repositories = realloc(_artifactInfoResource->repositories, (_artifactInfoResource->_sizeof_repositories + 1) * sizeof(struct nexus_indexer_lucene_plugin_ns0_repository_url_resource));
        memcpy(&(_artifactInfoResource->repositories[_artifactInfoResource->_sizeof_repositories++]), _child_accessor, sizeof(struct nexus_indexer_lucene_plugin_ns0_repository_url_resource));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "canDelete", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}canDelete of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}canDelete of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Artifact_info_resourceType(_artifactInfoResource);
          free(_artifactInfoResource);
          return NULL;
        }

        _artifactInfoResource->canDelete = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}artifact-info-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}artifact-info-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _artifactInfoResource;
}

/**
 * Writes a ArtifactInfoResource to XML.
 *
 * @param writer The XML writer.
 * @param _artifactInfoResource The ArtifactInfoResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Artifact_info_resourceType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource *_artifactInfoResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "presentLocally", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}presentLocally. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}presentLocally...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_artifactInfoResource->presentLocally));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}presentLocally. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}presentLocally. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_artifactInfoResource->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_artifactInfoResource->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_artifactInfoResource->repositoryName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_artifactInfoResource->repositoryName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_artifactInfoResource->repositoryPath != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryPath", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryPath. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryPath...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_artifactInfoResource->repositoryPath));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryPath. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryPath. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_artifactInfoResource->mimeType != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "mimeType", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}mimeType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}mimeType...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_artifactInfoResource->mimeType));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}mimeType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}mimeType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_artifactInfoResource->uploader != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "uploader", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}uploader. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}uploader...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_artifactInfoResource->uploader));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}uploader. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}uploader. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "uploaded", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}uploaded. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}long for element {}uploaded...\n", status);
#endif
    status = xmlTextWriterWriteXsLongType(writer, &(_artifactInfoResource->uploaded));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}long for element {}uploaded. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}uploaded. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "lastChanged", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}lastChanged. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}long for element {}lastChanged...\n", status);
#endif
    status = xmlTextWriterWriteXsLongType(writer, &(_artifactInfoResource->lastChanged));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}long for element {}lastChanged. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}lastChanged. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "size", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}size. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}long for element {}size...\n", status);
#endif
    status = xmlTextWriterWriteXsLongType(writer, &(_artifactInfoResource->size));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}long for element {}size. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}size. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_artifactInfoResource->sha1Hash != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "sha1Hash", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}sha1Hash. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}sha1Hash...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_artifactInfoResource->sha1Hash));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}sha1Hash. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}sha1Hash. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_artifactInfoResource->md5Hash != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "md5Hash", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}md5Hash. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}md5Hash...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_artifactInfoResource->md5Hash));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}md5Hash. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}md5Hash. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_artifactInfoResource->repositories != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _artifactInfoResource->_sizeof_repositories; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositories", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositories. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repository-url-resource for element {}repositories...\n", status);
#endif
    status = xmlTextWriterWriteNs0Repository_url_resourceType(writer, &(_artifactInfoResource->repositories[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repository-url-resource for element {}repositories. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositories. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_artifactInfoResource->repositories != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "canDelete", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}canDelete. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}canDelete...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_artifactInfoResource->canDelete));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}canDelete. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}canDelete. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ArtifactInfoResource.
 *
 * @param _artifactInfoResource The ArtifactInfoResource to free.
 */
static void freeNs0Artifact_info_resourceType(struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource *_artifactInfoResource) {
  int i;
  if (_artifactInfoResource->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    freeXsStringType(_artifactInfoResource->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    free(_artifactInfoResource->repositoryId);
  }
  if (_artifactInfoResource->repositoryName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryName of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    freeXsStringType(_artifactInfoResource->repositoryName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryName of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    free(_artifactInfoResource->repositoryName);
  }
  if (_artifactInfoResource->repositoryPath != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryPath of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    freeXsStringType(_artifactInfoResource->repositoryPath);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryPath of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    free(_artifactInfoResource->repositoryPath);
  }
  if (_artifactInfoResource->mimeType != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor mimeType of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    freeXsStringType(_artifactInfoResource->mimeType);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor mimeType of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    free(_artifactInfoResource->mimeType);
  }
  if (_artifactInfoResource->uploader != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor uploader of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    freeXsStringType(_artifactInfoResource->uploader);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor uploader of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    free(_artifactInfoResource->uploader);
  }
  if (_artifactInfoResource->sha1Hash != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor sha1Hash of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    freeXsStringType(_artifactInfoResource->sha1Hash);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor sha1Hash of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    free(_artifactInfoResource->sha1Hash);
  }
  if (_artifactInfoResource->md5Hash != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor md5Hash of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    freeXsStringType(_artifactInfoResource->md5Hash);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor md5Hash of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    free(_artifactInfoResource->md5Hash);
  }
  if (_artifactInfoResource->repositories != NULL) {
    for (i = 0; i < _artifactInfoResource->_sizeof_repositories; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor repositories[%i] of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n", i);
#endif
      freeNs0Repository_url_resourceType(&(_artifactInfoResource->repositories[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositories of type nexus_indexer_lucene_plugin_ns0_artifact_info_resource...\n");
#endif
    free(_artifactInfoResource->repositories);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_artifact_info_resource_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse_M
#define DEF_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse_M

/**
 * Reads a ArtifactInfoResourceResponse element from XML. The element to be read is "artifact-info", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ArtifactInfoResourceResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *xml_read_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Artifact_infoElement(reader);
}

/**
 * Writes a ArtifactInfoResourceResponse to XML under element name "artifact-info".
 *
 * @param writer The XML writer.
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse) {
  return xmlTextWriterWriteNs0Artifact_infoElementNS(writer, _artifactInfoResourceResponse, 1);
}

/**
 * Frees a ArtifactInfoResourceResponse.
 *
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to free.
 */
void free_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse(struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse) {
  freeNs0ArtifactInfoResourceResponseType(_artifactInfoResourceResponse);
  free(_artifactInfoResourceResponse);
}

/**
 * Reads a ArtifactInfoResourceResponse element from XML. The element to be read is "artifact-info", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ArtifactInfoResourceResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *xmlTextReaderReadNs0Artifact_infoElement(xmlTextReaderPtr reader) {
  struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "artifact-info", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}artifact-info.\n");
#endif
    _artifactInfoResourceResponse = xmlTextReaderReadNs0ArtifactInfoResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_artifactInfoResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}artifact-info failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}artifact-info failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _artifactInfoResourceResponse;
}

/**
 * Writes a ArtifactInfoResourceResponse to XML under element name "artifact-info".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Artifact_infoElement(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse) {
  return xmlTextWriterWriteNs0Artifact_infoElementNS(writer, _artifactInfoResourceResponse, 0);
}

/**
 * Writes a ArtifactInfoResourceResponse to XML under element name "artifact-info".
 *
 * @param writer The XML writer.
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Artifact_infoElementNS(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifact-info", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}artifact-info. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}artifactInfoResourceResponse for root element {}artifact-info...\n");
#endif
  status = xmlTextWriterWriteNs0ArtifactInfoResourceResponseType(writer, _artifactInfoResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}artifact-info. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}artifact-info. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ArtifactInfoResourceResponse.
 *
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse whose children are to be free.
 */
static void freeNs0Artifact_infoElement(struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse) {
  freeNs0ArtifactInfoResourceResponseType(_artifactInfoResourceResponse);
}

/**
 * Reads a ArtifactInfoResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the ArtifactInfoResourceResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *xmlTextReaderReadNs0ArtifactInfoResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ArtifactInfoResourceResponseType(_artifactInfoResourceResponse);
        free(_artifactInfoResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}artifact-info-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Artifact_info_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}artifact-info-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactInfoResourceResponseType(_artifactInfoResourceResponse);
          free(_artifactInfoResourceResponse);
          return NULL;
        }

        _artifactInfoResourceResponse->data = ((struct nexus_indexer_lucene_plugin_ns0_artifact_info_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}artifactInfoResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}artifactInfoResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _artifactInfoResourceResponse;
}

/**
 * Writes a ArtifactInfoResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ArtifactInfoResourceResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_artifactInfoResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}artifact-info-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Artifact_info_resourceType(writer, (_artifactInfoResourceResponse->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}artifact-info-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ArtifactInfoResourceResponse.
 *
 * @param _artifactInfoResourceResponse The ArtifactInfoResourceResponse to free.
 */
static void freeNs0ArtifactInfoResourceResponseType(struct nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse *_artifactInfoResourceResponse) {
  int i;
  if (_artifactInfoResourceResponse->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse...\n");
#endif
    freeNs0Artifact_info_resourceType(_artifactInfoResourceResponse->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse...\n");
#endif
    free(_artifactInfoResourceResponse->data);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_artifactInfoResourceResponse_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_nexus_artifact_M
#define DEF_nexus_indexer_lucene_plugin_ns0_nexus_artifact_M

/**
 * Reads a NexusArtifact from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusArtifact, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_nexus_artifact *xmlTextReaderReadNs0Nexus_artifactType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_nexus_artifact *_nexusArtifact = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_nexus_artifact));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Nexus_artifactType(_nexusArtifact);
        free(_nexusArtifact);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->groupId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->artifactId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "version", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}version of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}version of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->version = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "classifier", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}classifier of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}classifier of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->classifier = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "packaging", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}packaging of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}packaging of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->packaging = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "extension", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}extension of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}extension of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->extension = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repoId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repoId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repoId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->repoId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contextId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contextId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contextId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->contextId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "pomLink", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}pomLink of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}pomLink of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->pomLink = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactLink", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactLink of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactLink of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->artifactLink = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "highlightedFragment", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}highlightedFragment of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}highlightedFragment of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Nexus_artifactType(_nexusArtifact);
          free(_nexusArtifact);
          return NULL;
        }

        _nexusArtifact->highlightedFragment = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}nexus-artifact.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}nexus-artifact. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _nexusArtifact;
}

/**
 * Writes a NexusArtifact to XML.
 *
 * @param writer The XML writer.
 * @param _nexusArtifact The NexusArtifact to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Nexus_artifactType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_nexus_artifact *_nexusArtifact) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_nexusArtifact->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->groupId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->groupId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->artifactId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}artifactId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->artifactId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->version != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "version", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}version...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->version));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->classifier != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "classifier", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}classifier. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}classifier...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->classifier));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}classifier. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}classifier. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->packaging != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "packaging", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}packaging. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}packaging...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->packaging));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}packaging. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}packaging. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->extension != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "extension", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}extension. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}extension...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->extension));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}extension. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}extension. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->repoId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repoId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repoId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repoId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->repoId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repoId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repoId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->contextId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contextId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contextId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contextId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->contextId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contextId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contextId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->pomLink != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "pomLink", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}pomLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}pomLink...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->pomLink));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}pomLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}pomLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->artifactLink != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactLink", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}artifactLink...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->artifactLink));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}artifactLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusArtifact->highlightedFragment != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "highlightedFragment", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}highlightedFragment. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}highlightedFragment...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusArtifact->highlightedFragment));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}highlightedFragment. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}highlightedFragment. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a NexusArtifact.
 *
 * @param _nexusArtifact The NexusArtifact to free.
 */
static void freeNs0Nexus_artifactType(struct nexus_indexer_lucene_plugin_ns0_nexus_artifact *_nexusArtifact) {
  int i;
  if (_nexusArtifact->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->resourceURI);
  }
  if (_nexusArtifact->groupId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupId of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->groupId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupId of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->groupId);
  }
  if (_nexusArtifact->artifactId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor artifactId of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->artifactId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor artifactId of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->artifactId);
  }
  if (_nexusArtifact->version != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor version of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->version);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor version of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->version);
  }
  if (_nexusArtifact->classifier != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor classifier of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->classifier);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor classifier of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->classifier);
  }
  if (_nexusArtifact->packaging != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor packaging of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->packaging);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor packaging of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->packaging);
  }
  if (_nexusArtifact->extension != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor extension of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->extension);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor extension of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->extension);
  }
  if (_nexusArtifact->repoId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repoId of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->repoId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repoId of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->repoId);
  }
  if (_nexusArtifact->contextId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contextId of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->contextId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contextId of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->contextId);
  }
  if (_nexusArtifact->pomLink != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor pomLink of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->pomLink);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor pomLink of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->pomLink);
  }
  if (_nexusArtifact->artifactLink != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor artifactLink of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->artifactLink);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor artifactLink of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->artifactLink);
  }
  if (_nexusArtifact->highlightedFragment != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor highlightedFragment of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    freeXsStringType(_nexusArtifact->highlightedFragment);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor highlightedFragment of type nexus_indexer_lucene_plugin_ns0_nexus_artifact...\n");
#endif
    free(_nexusArtifact->highlightedFragment);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_nexus_artifact_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse_M
#define DEF_nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse_M

/**
 * Reads a NexusIndexerResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusIndexerResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse *xmlTextReaderReadNs0NexusIndexerResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse *_nexusIndexerResponse = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse));




  return _nexusIndexerResponse;
}

/**
 * Writes a NexusIndexerResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusIndexerResponse The NexusIndexerResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0NexusIndexerResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse *_nexusIndexerResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  return totalBytes;
}

/**
 * Frees the elements of a NexusIndexerResponse.
 *
 * @param _nexusIndexerResponse The NexusIndexerResponse to free.
 */
static void freeNs0NexusIndexerResponseType(struct nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse *_nexusIndexerResponse) {
  int i;
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_nexusIndexerResponse_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_nexusNGArtifact_M
#define DEF_nexus_indexer_lucene_plugin_ns0_nexusNGArtifact_M

/**
 * Reads a NexusNGArtifact from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusNGArtifact, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact *xmlTextReaderReadNs0NexusNGArtifactType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact *_nexusNGArtifact = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0NexusNGArtifactType(_nexusNGArtifact);
        free(_nexusNGArtifact);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->groupId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->artifactId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "version", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}version of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}version of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->version = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "latestSnapshot", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}latestSnapshot of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}latestSnapshot of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->latestSnapshot = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "latestSnapshotRepositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}latestSnapshotRepositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}latestSnapshotRepositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->latestSnapshotRepositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "latestRelease", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}latestRelease of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}latestRelease of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->latestRelease = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "latestReleaseRepositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}latestReleaseRepositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}latestReleaseRepositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->latestReleaseRepositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "highlightedFragment", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}highlightedFragment of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}highlightedFragment of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->highlightedFragment = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactHits", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}artifactHits...\n");
#endif
          //start wrapper element "{}artifactHits"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0NexusNGArtifactType(_nexusNGArtifact);
              free(_nexusNGArtifact);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactHit", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactHit of type {}artifactHit.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ArtifactHitType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactHit of type {}artifactHit.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }

        _nexusNGArtifact->artifactHits = realloc(_nexusNGArtifact->artifactHits, (_nexusNGArtifact->_sizeof_artifactHits + 1) * sizeof(struct nexus_indexer_lucene_plugin_ns0_artifactHit));
        memcpy(&(_nexusNGArtifact->artifactHits[_nexusNGArtifact->_sizeof_artifactHits++]), _child_accessor, sizeof(struct nexus_indexer_lucene_plugin_ns0_artifactHit));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}artifactHits.\n");
#endif
          freeNs0NexusNGArtifactType(_nexusNGArtifact);
          free(_nexusNGArtifact);
          return NULL;
        }
        else {
          //end wrapper element "{}artifactHits"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}nexusNGArtifact.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}nexusNGArtifact. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _nexusNGArtifact;
}

/**
 * Writes a NexusNGArtifact to XML.
 *
 * @param writer The XML writer.
 * @param _nexusNGArtifact The NexusNGArtifact to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0NexusNGArtifactType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact *_nexusNGArtifact) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_nexusNGArtifact->groupId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifact->groupId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGArtifact->artifactId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}artifactId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifact->artifactId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGArtifact->version != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "version", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}version...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifact->version));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGArtifact->latestSnapshot != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "latestSnapshot", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}latestSnapshot. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}latestSnapshot...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifact->latestSnapshot));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}latestSnapshot. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}latestSnapshot. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGArtifact->latestSnapshotRepositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "latestSnapshotRepositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}latestSnapshotRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}latestSnapshotRepositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifact->latestSnapshotRepositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}latestSnapshotRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}latestSnapshotRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGArtifact->latestRelease != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "latestRelease", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}latestRelease. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}latestRelease...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifact->latestRelease));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}latestRelease. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}latestRelease. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGArtifact->latestReleaseRepositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "latestReleaseRepositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}latestReleaseRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}latestReleaseRepositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifact->latestReleaseRepositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}latestReleaseRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}latestReleaseRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGArtifact->highlightedFragment != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "highlightedFragment", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}highlightedFragment. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}highlightedFragment...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifact->highlightedFragment));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}highlightedFragment. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}highlightedFragment. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_nexusNGArtifact->artifactHits != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactHits", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactHits. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _nexusNGArtifact->_sizeof_artifactHits; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactHit", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactHit. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}artifactHit for element {}artifactHit...\n", status);
#endif
    status = xmlTextWriterWriteNs0ArtifactHitType(writer, &(_nexusNGArtifact->artifactHits[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}artifactHit for element {}artifactHit. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactHit. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_nexusNGArtifact->artifactHits != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactHits. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a NexusNGArtifact.
 *
 * @param _nexusNGArtifact The NexusNGArtifact to free.
 */
static void freeNs0NexusNGArtifactType(struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact *_nexusNGArtifact) {
  int i;
  if (_nexusNGArtifact->groupId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupId of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    freeXsStringType(_nexusNGArtifact->groupId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupId of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->groupId);
  }
  if (_nexusNGArtifact->artifactId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor artifactId of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    freeXsStringType(_nexusNGArtifact->artifactId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor artifactId of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->artifactId);
  }
  if (_nexusNGArtifact->version != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor version of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    freeXsStringType(_nexusNGArtifact->version);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor version of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->version);
  }
  if (_nexusNGArtifact->latestSnapshot != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor latestSnapshot of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    freeXsStringType(_nexusNGArtifact->latestSnapshot);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor latestSnapshot of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->latestSnapshot);
  }
  if (_nexusNGArtifact->latestSnapshotRepositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor latestSnapshotRepositoryId of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    freeXsStringType(_nexusNGArtifact->latestSnapshotRepositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor latestSnapshotRepositoryId of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->latestSnapshotRepositoryId);
  }
  if (_nexusNGArtifact->latestRelease != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor latestRelease of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    freeXsStringType(_nexusNGArtifact->latestRelease);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor latestRelease of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->latestRelease);
  }
  if (_nexusNGArtifact->latestReleaseRepositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor latestReleaseRepositoryId of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    freeXsStringType(_nexusNGArtifact->latestReleaseRepositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor latestReleaseRepositoryId of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->latestReleaseRepositoryId);
  }
  if (_nexusNGArtifact->highlightedFragment != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor highlightedFragment of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    freeXsStringType(_nexusNGArtifact->highlightedFragment);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor highlightedFragment of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->highlightedFragment);
  }
  if (_nexusNGArtifact->artifactHits != NULL) {
    for (i = 0; i < _nexusNGArtifact->_sizeof_artifactHits; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor artifactHits[%i] of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n", i);
#endif
      freeNs0ArtifactHitType(&(_nexusNGArtifact->artifactHits[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor artifactHits of type nexus_indexer_lucene_plugin_ns0_nexusNGArtifact...\n");
#endif
    free(_nexusNGArtifact->artifactHits);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_nexusNGArtifact_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_artifactHit_M
#define DEF_nexus_indexer_lucene_plugin_ns0_artifactHit_M

/**
 * Reads a NexusNGArtifactHit from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusNGArtifactHit, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_artifactHit *xmlTextReaderReadNs0ArtifactHitType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_artifactHit *_nexusNGArtifactHit = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_artifactHit));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ArtifactHitType(_nexusNGArtifactHit);
        free(_nexusNGArtifactHit);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactHitType(_nexusNGArtifactHit);
          free(_nexusNGArtifactHit);
          return NULL;
        }

        _nexusNGArtifactHit->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactLinks", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}artifactLinks...\n");
#endif
          //start wrapper element "{}artifactLinks"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0ArtifactHitType(_nexusNGArtifactHit);
              free(_nexusNGArtifactHit);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactLink", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactLink of type {}artifactLink.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ArtifactLinkType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactLink of type {}artifactLink.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactHitType(_nexusNGArtifactHit);
          free(_nexusNGArtifactHit);
          return NULL;
        }

        _nexusNGArtifactHit->artifactLinks = realloc(_nexusNGArtifactHit->artifactLinks, (_nexusNGArtifactHit->_sizeof_artifactLinks + 1) * sizeof(struct nexus_indexer_lucene_plugin_ns0_artifactLink));
        memcpy(&(_nexusNGArtifactHit->artifactLinks[_nexusNGArtifactHit->_sizeof_artifactLinks++]), _child_accessor, sizeof(struct nexus_indexer_lucene_plugin_ns0_artifactLink));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}artifactLinks.\n");
#endif
          freeNs0ArtifactHitType(_nexusNGArtifactHit);
          free(_nexusNGArtifactHit);
          return NULL;
        }
        else {
          //end wrapper element "{}artifactLinks"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}artifactHit.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}artifactHit. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _nexusNGArtifactHit;
}

/**
 * Writes a NexusNGArtifactHit to XML.
 *
 * @param writer The XML writer.
 * @param _nexusNGArtifactHit The NexusNGArtifactHit to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ArtifactHitType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactHit *_nexusNGArtifactHit) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_nexusNGArtifactHit->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifactHit->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_nexusNGArtifactHit->artifactLinks != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactLinks", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactLinks. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _nexusNGArtifactHit->_sizeof_artifactLinks; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactLink", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}artifactLink for element {}artifactLink...\n", status);
#endif
    status = xmlTextWriterWriteNs0ArtifactLinkType(writer, &(_nexusNGArtifactHit->artifactLinks[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}artifactLink for element {}artifactLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactLink. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_nexusNGArtifactHit->artifactLinks != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactLinks. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a NexusNGArtifactHit.
 *
 * @param _nexusNGArtifactHit The NexusNGArtifactHit to free.
 */
static void freeNs0ArtifactHitType(struct nexus_indexer_lucene_plugin_ns0_artifactHit *_nexusNGArtifactHit) {
  int i;
  if (_nexusNGArtifactHit->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_indexer_lucene_plugin_ns0_artifactHit...\n");
#endif
    freeXsStringType(_nexusNGArtifactHit->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_indexer_lucene_plugin_ns0_artifactHit...\n");
#endif
    free(_nexusNGArtifactHit->repositoryId);
  }
  if (_nexusNGArtifactHit->artifactLinks != NULL) {
    for (i = 0; i < _nexusNGArtifactHit->_sizeof_artifactLinks; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor artifactLinks[%i] of type nexus_indexer_lucene_plugin_ns0_artifactHit...\n", i);
#endif
      freeNs0ArtifactLinkType(&(_nexusNGArtifactHit->artifactLinks[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor artifactLinks of type nexus_indexer_lucene_plugin_ns0_artifactHit...\n");
#endif
    free(_nexusNGArtifactHit->artifactLinks);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_artifactHit_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_artifactLink_M
#define DEF_nexus_indexer_lucene_plugin_ns0_artifactLink_M

/**
 * Reads a NexusNGArtifactLink from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusNGArtifactLink, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_artifactLink *xmlTextReaderReadNs0ArtifactLinkType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_artifactLink *_nexusNGArtifactLink = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_artifactLink));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ArtifactLinkType(_nexusNGArtifactLink);
        free(_nexusNGArtifactLink);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "classifier", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}classifier of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}classifier of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactLinkType(_nexusNGArtifactLink);
          free(_nexusNGArtifactLink);
          return NULL;
        }

        _nexusNGArtifactLink->classifier = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "extension", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}extension of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}extension of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactLinkType(_nexusNGArtifactLink);
          free(_nexusNGArtifactLink);
          return NULL;
        }

        _nexusNGArtifactLink->extension = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}artifactLink.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}artifactLink. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _nexusNGArtifactLink;
}

/**
 * Writes a NexusNGArtifactLink to XML.
 *
 * @param writer The XML writer.
 * @param _nexusNGArtifactLink The NexusNGArtifactLink to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ArtifactLinkType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_artifactLink *_nexusNGArtifactLink) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_nexusNGArtifactLink->classifier != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "classifier", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}classifier. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}classifier...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifactLink->classifier));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}classifier. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}classifier. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGArtifactLink->extension != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "extension", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}extension. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}extension...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGArtifactLink->extension));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}extension. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}extension. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a NexusNGArtifactLink.
 *
 * @param _nexusNGArtifactLink The NexusNGArtifactLink to free.
 */
static void freeNs0ArtifactLinkType(struct nexus_indexer_lucene_plugin_ns0_artifactLink *_nexusNGArtifactLink) {
  int i;
  if (_nexusNGArtifactLink->classifier != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor classifier of type nexus_indexer_lucene_plugin_ns0_artifactLink...\n");
#endif
    freeXsStringType(_nexusNGArtifactLink->classifier);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor classifier of type nexus_indexer_lucene_plugin_ns0_artifactLink...\n");
#endif
    free(_nexusNGArtifactLink->classifier);
  }
  if (_nexusNGArtifactLink->extension != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor extension of type nexus_indexer_lucene_plugin_ns0_artifactLink...\n");
#endif
    freeXsStringType(_nexusNGArtifactLink->extension);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor extension of type nexus_indexer_lucene_plugin_ns0_artifactLink...\n");
#endif
    free(_nexusNGArtifactLink->extension);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_artifactLink_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_repositoryDetail_M
#define DEF_nexus_indexer_lucene_plugin_ns0_repositoryDetail_M

/**
 * Reads a NexusNGRepositoryDetail from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusNGRepositoryDetail, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_repositoryDetail *xmlTextReaderReadNs0RepositoryDetailType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_repositoryDetail *_nexusNGRepositoryDetail = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_repositoryDetail));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RepositoryDetailType(_nexusNGRepositoryDetail);
        free(_nexusNGRepositoryDetail);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryDetailType(_nexusNGRepositoryDetail);
          free(_nexusNGRepositoryDetail);
          return NULL;
        }

        _nexusNGRepositoryDetail->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryDetailType(_nexusNGRepositoryDetail);
          free(_nexusNGRepositoryDetail);
          return NULL;
        }

        _nexusNGRepositoryDetail->repositoryName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryContentClass", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryContentClass of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryContentClass of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryDetailType(_nexusNGRepositoryDetail);
          free(_nexusNGRepositoryDetail);
          return NULL;
        }

        _nexusNGRepositoryDetail->repositoryContentClass = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryKind", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryKind of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryKind of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryDetailType(_nexusNGRepositoryDetail);
          free(_nexusNGRepositoryDetail);
          return NULL;
        }

        _nexusNGRepositoryDetail->repositoryKind = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryPolicy", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryPolicy of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryPolicy of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryDetailType(_nexusNGRepositoryDetail);
          free(_nexusNGRepositoryDetail);
          return NULL;
        }

        _nexusNGRepositoryDetail->repositoryPolicy = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryURL", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryURL of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryURL of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RepositoryDetailType(_nexusNGRepositoryDetail);
          free(_nexusNGRepositoryDetail);
          return NULL;
        }

        _nexusNGRepositoryDetail->repositoryURL = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repositoryDetail.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repositoryDetail. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _nexusNGRepositoryDetail;
}

/**
 * Writes a NexusNGRepositoryDetail to XML.
 *
 * @param writer The XML writer.
 * @param _nexusNGRepositoryDetail The NexusNGRepositoryDetail to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RepositoryDetailType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_repositoryDetail *_nexusNGRepositoryDetail) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_nexusNGRepositoryDetail->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGRepositoryDetail->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGRepositoryDetail->repositoryName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGRepositoryDetail->repositoryName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGRepositoryDetail->repositoryContentClass != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryContentClass", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryContentClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryContentClass...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGRepositoryDetail->repositoryContentClass));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryContentClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryContentClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGRepositoryDetail->repositoryKind != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryKind", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryKind. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryKind...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGRepositoryDetail->repositoryKind));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryKind. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryKind. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGRepositoryDetail->repositoryPolicy != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryPolicy", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryPolicy. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryPolicy...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGRepositoryDetail->repositoryPolicy));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryPolicy. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryPolicy. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_nexusNGRepositoryDetail->repositoryURL != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryURL", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryURL. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryURL...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_nexusNGRepositoryDetail->repositoryURL));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryURL. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryURL. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a NexusNGRepositoryDetail.
 *
 * @param _nexusNGRepositoryDetail The NexusNGRepositoryDetail to free.
 */
static void freeNs0RepositoryDetailType(struct nexus_indexer_lucene_plugin_ns0_repositoryDetail *_nexusNGRepositoryDetail) {
  int i;
  if (_nexusNGRepositoryDetail->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    freeXsStringType(_nexusNGRepositoryDetail->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    free(_nexusNGRepositoryDetail->repositoryId);
  }
  if (_nexusNGRepositoryDetail->repositoryName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryName of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    freeXsStringType(_nexusNGRepositoryDetail->repositoryName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryName of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    free(_nexusNGRepositoryDetail->repositoryName);
  }
  if (_nexusNGRepositoryDetail->repositoryContentClass != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryContentClass of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    freeXsStringType(_nexusNGRepositoryDetail->repositoryContentClass);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryContentClass of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    free(_nexusNGRepositoryDetail->repositoryContentClass);
  }
  if (_nexusNGRepositoryDetail->repositoryKind != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryKind of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    freeXsStringType(_nexusNGRepositoryDetail->repositoryKind);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryKind of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    free(_nexusNGRepositoryDetail->repositoryKind);
  }
  if (_nexusNGRepositoryDetail->repositoryPolicy != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryPolicy of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    freeXsStringType(_nexusNGRepositoryDetail->repositoryPolicy);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryPolicy of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    free(_nexusNGRepositoryDetail->repositoryPolicy);
  }
  if (_nexusNGRepositoryDetail->repositoryURL != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryURL of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    freeXsStringType(_nexusNGRepositoryDetail->repositoryURL);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryURL of type nexus_indexer_lucene_plugin_ns0_repositoryDetail...\n");
#endif
    free(_nexusNGRepositoryDetail->repositoryURL);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_repositoryDetail_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_nexusResponse_M
#define DEF_nexus_indexer_lucene_plugin_ns0_nexusResponse_M

/**
 * Reads a NexusResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_nexusResponse *xmlTextReaderReadNs0NexusResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_nexusResponse *_nexusResponse = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_nexusResponse));




  return _nexusResponse;
}

/**
 * Writes a NexusResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusResponse The NexusResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0NexusResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_nexusResponse *_nexusResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  return totalBytes;
}

/**
 * Frees the elements of a NexusResponse.
 *
 * @param _nexusResponse The NexusResponse to free.
 */
static void freeNs0NexusResponseType(struct nexus_indexer_lucene_plugin_ns0_nexusResponse *_nexusResponse) {
  int i;
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_nexusResponse_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_repository_url_resource_M
#define DEF_nexus_indexer_lucene_plugin_ns0_repository_url_resource_M

/**
 * Reads a RepositoryUrlResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RepositoryUrlResource, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_repository_url_resource *xmlTextReaderReadNs0Repository_url_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_repository_url_resource *_repositoryUrlResource = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_repository_url_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Repository_url_resourceType(_repositoryUrlResource);
        free(_repositoryUrlResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_url_resourceType(_repositoryUrlResource);
          free(_repositoryUrlResource);
          return NULL;
        }

        _repositoryUrlResource->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_url_resourceType(_repositoryUrlResource);
          free(_repositoryUrlResource);
          return NULL;
        }

        _repositoryUrlResource->repositoryName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "path", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}path of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}path of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_url_resourceType(_repositoryUrlResource);
          free(_repositoryUrlResource);
          return NULL;
        }

        _repositoryUrlResource->path = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactUrl", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_url_resourceType(_repositoryUrlResource);
          free(_repositoryUrlResource);
          return NULL;
        }

        _repositoryUrlResource->artifactUrl = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "canView", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}canView of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}canView of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Repository_url_resourceType(_repositoryUrlResource);
          free(_repositoryUrlResource);
          return NULL;
        }

        _repositoryUrlResource->canView = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}repository-url-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}repository-url-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _repositoryUrlResource;
}

/**
 * Writes a RepositoryUrlResource to XML.
 *
 * @param writer The XML writer.
 * @param _repositoryUrlResource The RepositoryUrlResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Repository_url_resourceType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_repository_url_resource *_repositoryUrlResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_repositoryUrlResource->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryUrlResource->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryUrlResource->repositoryName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryUrlResource->repositoryName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryUrlResource->path != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "path", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}path. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}path...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryUrlResource->path));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}path. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}path. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_repositoryUrlResource->artifactUrl != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactUrl", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}artifactUrl...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_repositoryUrlResource->artifactUrl));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}artifactUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "canView", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}canView. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}canView...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_repositoryUrlResource->canView));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}canView. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}canView. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RepositoryUrlResource.
 *
 * @param _repositoryUrlResource The RepositoryUrlResource to free.
 */
static void freeNs0Repository_url_resourceType(struct nexus_indexer_lucene_plugin_ns0_repository_url_resource *_repositoryUrlResource) {
  int i;
  if (_repositoryUrlResource->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_indexer_lucene_plugin_ns0_repository_url_resource...\n");
#endif
    freeXsStringType(_repositoryUrlResource->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_indexer_lucene_plugin_ns0_repository_url_resource...\n");
#endif
    free(_repositoryUrlResource->repositoryId);
  }
  if (_repositoryUrlResource->repositoryName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryName of type nexus_indexer_lucene_plugin_ns0_repository_url_resource...\n");
#endif
    freeXsStringType(_repositoryUrlResource->repositoryName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryName of type nexus_indexer_lucene_plugin_ns0_repository_url_resource...\n");
#endif
    free(_repositoryUrlResource->repositoryName);
  }
  if (_repositoryUrlResource->path != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor path of type nexus_indexer_lucene_plugin_ns0_repository_url_resource...\n");
#endif
    freeXsStringType(_repositoryUrlResource->path);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor path of type nexus_indexer_lucene_plugin_ns0_repository_url_resource...\n");
#endif
    free(_repositoryUrlResource->path);
  }
  if (_repositoryUrlResource->artifactUrl != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor artifactUrl of type nexus_indexer_lucene_plugin_ns0_repository_url_resource...\n");
#endif
    freeXsStringType(_repositoryUrlResource->artifactUrl);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor artifactUrl of type nexus_indexer_lucene_plugin_ns0_repository_url_resource...\n");
#endif
    free(_repositoryUrlResource->artifactUrl);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_repository_url_resource_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_searchNGResponse_M
#define DEF_nexus_indexer_lucene_plugin_ns0_searchNGResponse_M

/**
 * Reads a SearchNGResponse element from XML. The element to be read is "searchNGResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SearchNGResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *xml_read_nexus_indexer_lucene_plugin_ns0_searchNGResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0SearchNGResponseElement(reader);
}

/**
 * Writes a SearchNGResponse to XML under element name "searchNGResponse".
 *
 * @param writer The XML writer.
 * @param _searchNGResponse The SearchNGResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_indexer_lucene_plugin_ns0_searchNGResponse(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse) {
  return xmlTextWriterWriteNs0SearchNGResponseElementNS(writer, _searchNGResponse, 1);
}

/**
 * Frees a SearchNGResponse.
 *
 * @param _searchNGResponse The SearchNGResponse to free.
 */
void free_nexus_indexer_lucene_plugin_ns0_searchNGResponse(struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse) {
  freeNs0SearchNGResponseType(_searchNGResponse);
  free(_searchNGResponse);
}

/**
 * Reads a SearchNGResponse element from XML. The element to be read is "searchNGResponse", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The SearchNGResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *xmlTextReaderReadNs0SearchNGResponseElement(xmlTextReaderPtr reader) {
  struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "searchNGResponse", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}searchNGResponse.\n");
#endif
    _searchNGResponse = xmlTextReaderReadNs0SearchNGResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_searchNGResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}searchNGResponse failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}searchNGResponse failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _searchNGResponse;
}

/**
 * Writes a SearchNGResponse to XML under element name "searchNGResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _searchNGResponse The SearchNGResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0SearchNGResponseElement(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse) {
  return xmlTextWriterWriteNs0SearchNGResponseElementNS(writer, _searchNGResponse, 0);
}

/**
 * Writes a SearchNGResponse to XML under element name "searchNGResponse".
 *
 * @param writer The XML writer.
 * @param _searchNGResponse The SearchNGResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0SearchNGResponseElementNS(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "searchNGResponse", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}searchNGResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}searchNGResponse for root element {}searchNGResponse...\n");
#endif
  status = xmlTextWriterWriteNs0SearchNGResponseType(writer, _searchNGResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}searchNGResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}searchNGResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a SearchNGResponse.
 *
 * @param _searchNGResponse The SearchNGResponse whose children are to be free.
 */
static void freeNs0SearchNGResponseElement(struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse) {
  freeNs0SearchNGResponseType(_searchNGResponse);
}

/**
 * Reads a SearchNGResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the SearchNGResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *xmlTextReaderReadNs0SearchNGResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_searchNGResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SearchNGResponseType(_searchNGResponse);
        free(_searchNGResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "totalCount", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}totalCount of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}totalCount of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }

        _searchNGResponse->totalCount = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "from", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}from of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}from of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }

        _searchNGResponse->from = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "count", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}count of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}count of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }

        _searchNGResponse->count = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "tooManyResults", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}tooManyResults of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}tooManyResults of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }

        _searchNGResponse->tooManyResults = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "collapsed", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}collapsed of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}collapsed of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }

        _searchNGResponse->collapsed = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repoDetails", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}repoDetails...\n");
#endif
          //start wrapper element "{}repoDetails"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0SearchNGResponseType(_searchNGResponse);
              free(_searchNGResponse);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryDetail", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryDetail of type {}repositoryDetail.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0RepositoryDetailType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryDetail of type {}repositoryDetail.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }

        _searchNGResponse->repoDetails = realloc(_searchNGResponse->repoDetails, (_searchNGResponse->_sizeof_repoDetails + 1) * sizeof(struct nexus_indexer_lucene_plugin_ns0_repositoryDetail));
        memcpy(&(_searchNGResponse->repoDetails[_searchNGResponse->_sizeof_repoDetails++]), _child_accessor, sizeof(struct nexus_indexer_lucene_plugin_ns0_repositoryDetail));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}repoDetails.\n");
#endif
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }
        else {
          //end wrapper element "{}repoDetails"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0SearchNGResponseType(_searchNGResponse);
              free(_searchNGResponse);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "nexusNGArtifact", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}nexusNGArtifact of type {}nexusNGArtifact.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0NexusNGArtifactType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}nexusNGArtifact of type {}nexusNGArtifact.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }

        _searchNGResponse->data = realloc(_searchNGResponse->data, (_searchNGResponse->_sizeof_data + 1) * sizeof(struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact));
        memcpy(&(_searchNGResponse->data[_searchNGResponse->_sizeof_data++]), _child_accessor, sizeof(struct nexus_indexer_lucene_plugin_ns0_nexusNGArtifact));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0SearchNGResponseType(_searchNGResponse);
          free(_searchNGResponse);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}searchNGResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}searchNGResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _searchNGResponse;
}

/**
 * Writes a SearchNGResponse to XML.
 *
 * @param writer The XML writer.
 * @param _searchNGResponse The SearchNGResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SearchNGResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "totalCount", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}totalCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}totalCount...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_searchNGResponse->totalCount));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}totalCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}totalCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "from", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}from. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}from...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_searchNGResponse->from));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}from. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}from. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "count", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}count. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}count...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_searchNGResponse->count));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}count. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}count. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "tooManyResults", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}tooManyResults. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}tooManyResults...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_searchNGResponse->tooManyResults));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}tooManyResults. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}tooManyResults. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "collapsed", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}collapsed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}collapsed...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_searchNGResponse->collapsed));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}collapsed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}collapsed. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_searchNGResponse->repoDetails != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repoDetails", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repoDetails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _searchNGResponse->_sizeof_repoDetails; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryDetail", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryDetail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}repositoryDetail for element {}repositoryDetail...\n", status);
#endif
    status = xmlTextWriterWriteNs0RepositoryDetailType(writer, &(_searchNGResponse->repoDetails[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}repositoryDetail for element {}repositoryDetail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryDetail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_searchNGResponse->repoDetails != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repoDetails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_searchNGResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _searchNGResponse->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "nexusNGArtifact", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}nexusNGArtifact. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}nexusNGArtifact for element {}nexusNGArtifact...\n", status);
#endif
    status = xmlTextWriterWriteNs0NexusNGArtifactType(writer, &(_searchNGResponse->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}nexusNGArtifact for element {}nexusNGArtifact. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}nexusNGArtifact. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_searchNGResponse->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SearchNGResponse.
 *
 * @param _searchNGResponse The SearchNGResponse to free.
 */
static void freeNs0SearchNGResponseType(struct nexus_indexer_lucene_plugin_ns0_searchNGResponse *_searchNGResponse) {
  int i;
  if (_searchNGResponse->repoDetails != NULL) {
    for (i = 0; i < _searchNGResponse->_sizeof_repoDetails; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor repoDetails[%i] of type nexus_indexer_lucene_plugin_ns0_searchNGResponse...\n", i);
#endif
      freeNs0RepositoryDetailType(&(_searchNGResponse->repoDetails[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repoDetails of type nexus_indexer_lucene_plugin_ns0_searchNGResponse...\n");
#endif
    free(_searchNGResponse->repoDetails);
  }
  if (_searchNGResponse->data != NULL) {
    for (i = 0; i < _searchNGResponse->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_indexer_lucene_plugin_ns0_searchNGResponse...\n", i);
#endif
      freeNs0NexusNGArtifactType(&(_searchNGResponse->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_indexer_lucene_plugin_ns0_searchNGResponse...\n");
#endif
    free(_searchNGResponse->data);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_searchNGResponse_M */
#ifndef DEF_nexus_indexer_lucene_plugin_ns0_searchResponse_M
#define DEF_nexus_indexer_lucene_plugin_ns0_searchResponse_M

/**
 * Reads a SearchResponse element from XML. The element to be read is "search-results", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SearchResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_searchResponse *xml_read_nexus_indexer_lucene_plugin_ns0_searchResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Search_resultsElement(reader);
}

/**
 * Writes a SearchResponse to XML under element name "search-results".
 *
 * @param writer The XML writer.
 * @param _searchResponse The SearchResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_indexer_lucene_plugin_ns0_searchResponse(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse) {
  return xmlTextWriterWriteNs0Search_resultsElementNS(writer, _searchResponse, 1);
}

/**
 * Frees a SearchResponse.
 *
 * @param _searchResponse The SearchResponse to free.
 */
void free_nexus_indexer_lucene_plugin_ns0_searchResponse(struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse) {
  freeNs0SearchResponseType(_searchResponse);
  free(_searchResponse);
}

/**
 * Reads a SearchResponse element from XML. The element to be read is "search-results", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The SearchResponse, or NULL in case of error.
 */
struct nexus_indexer_lucene_plugin_ns0_searchResponse *xmlTextReaderReadNs0Search_resultsElement(xmlTextReaderPtr reader) {
  struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "search-results", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}search-results.\n");
#endif
    _searchResponse = xmlTextReaderReadNs0SearchResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_searchResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}search-results failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}search-results failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _searchResponse;
}

/**
 * Writes a SearchResponse to XML under element name "search-results".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _searchResponse The SearchResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Search_resultsElement(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse) {
  return xmlTextWriterWriteNs0Search_resultsElementNS(writer, _searchResponse, 0);
}

/**
 * Writes a SearchResponse to XML under element name "search-results".
 *
 * @param writer The XML writer.
 * @param _searchResponse The SearchResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Search_resultsElementNS(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "search-results", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}search-results. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}searchResponse for root element {}search-results...\n");
#endif
  status = xmlTextWriterWriteNs0SearchResponseType(writer, _searchResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}search-results. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}search-results. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a SearchResponse.
 *
 * @param _searchResponse The SearchResponse whose children are to be free.
 */
static void freeNs0Search_resultsElement(struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse) {
  freeNs0SearchResponseType(_searchResponse);
}

/**
 * Reads a SearchResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the SearchResponse, or NULL in case of error.
 */
static struct nexus_indexer_lucene_plugin_ns0_searchResponse *xmlTextReaderReadNs0SearchResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse = calloc(1, sizeof(struct nexus_indexer_lucene_plugin_ns0_searchResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SearchResponseType(_searchResponse);
        free(_searchResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "totalCount", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}totalCount of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}totalCount of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchResponseType(_searchResponse);
          free(_searchResponse);
          return NULL;
        }

        _searchResponse->totalCount = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "from", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}from of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}from of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchResponseType(_searchResponse);
          free(_searchResponse);
          return NULL;
        }

        _searchResponse->from = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "count", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}count of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}count of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchResponseType(_searchResponse);
          free(_searchResponse);
          return NULL;
        }

        _searchResponse->count = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "tooManyResults", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}tooManyResults of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}tooManyResults of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchResponseType(_searchResponse);
          free(_searchResponse);
          return NULL;
        }

        _searchResponse->tooManyResults = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0SearchResponseType(_searchResponse);
              free(_searchResponse);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifact", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifact of type {}nexus-artifact.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Nexus_artifactType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifact of type {}nexus-artifact.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SearchResponseType(_searchResponse);
          free(_searchResponse);
          return NULL;
        }

        _searchResponse->data = realloc(_searchResponse->data, (_searchResponse->_sizeof_data + 1) * sizeof(struct nexus_indexer_lucene_plugin_ns0_nexus_artifact));
        memcpy(&(_searchResponse->data[_searchResponse->_sizeof_data++]), _child_accessor, sizeof(struct nexus_indexer_lucene_plugin_ns0_nexus_artifact));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0SearchResponseType(_searchResponse);
          free(_searchResponse);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}searchResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}searchResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _searchResponse;
}

/**
 * Writes a SearchResponse to XML.
 *
 * @param writer The XML writer.
 * @param _searchResponse The SearchResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SearchResponseType(xmlTextWriterPtr writer, struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "totalCount", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}totalCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}totalCount...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_searchResponse->totalCount));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}totalCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}totalCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "from", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}from. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}from...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_searchResponse->from));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}from. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}from. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "count", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}count. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}count...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_searchResponse->count));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}count. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}count. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "tooManyResults", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}tooManyResults. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}tooManyResults...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_searchResponse->tooManyResults));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}tooManyResults. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}tooManyResults. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_searchResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _searchResponse->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifact", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifact. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}nexus-artifact for element {}artifact...\n", status);
#endif
    status = xmlTextWriterWriteNs0Nexus_artifactType(writer, &(_searchResponse->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}nexus-artifact for element {}artifact. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifact. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_searchResponse->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SearchResponse.
 *
 * @param _searchResponse The SearchResponse to free.
 */
static void freeNs0SearchResponseType(struct nexus_indexer_lucene_plugin_ns0_searchResponse *_searchResponse) {
  int i;
  if (_searchResponse->data != NULL) {
    for (i = 0; i < _searchResponse->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_indexer_lucene_plugin_ns0_searchResponse...\n", i);
#endif
      freeNs0Nexus_artifactType(&(_searchResponse->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_indexer_lucene_plugin_ns0_searchResponse...\n");
#endif
    free(_searchResponse->data);
  }
}
#endif /* DEF_nexus_indexer_lucene_plugin_ns0_searchResponse_M */
